export declare type ComparatorFactory<K> = <T = any>(...keys: K[]) => Comparator<T>;
export interface Comparator<T> {
    (a: T, b: T): number;
    reversed(really?: boolean): Comparator<T>;
    or(anotherComparator: PureComparator<T>): Comparator<T>;
}
export interface ComparisonRule<K> {
    readonly selector?: (key: K) => (obj: any) => any;
    readonly specials?: SpecialHandling[];
    readonly collator?: Intl.CollatorOptions & {
        locales?: string | string[];
    } | {
        compare(a: string, b: string): number;
    };
}
export declare type PureComparator<T> = (a: T, b: T) => number;
export declare type SpecialHandling = [any, 'first' | 'last'];
export default function comparatorFactoryFactory<K = (obj: any) => any>(rule?: ComparisonRule<K>): ComparatorFactory<K>;
